// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class Ball extends cc.Component {


    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    private _collideWallCount: number = 0;//碰撞墙壁的次数
    private _collideWallCountTimeCheck: number = 0;//碰撞墙壁的检测时间

    @property(cc.RigidBody)
    public body: cc.RigidBody = null;

    onLoad(){
        this.body = this.getComponent(cc.RigidBody);
    }

    onBeginContact(contact: cc.PhysicsContact, selfCollider: cc.PhysicsCollider, otherCollider: cc.PhysicsCollider): void {
        if (otherCollider.node.group == "wall") { //注意标记 group
            //标记无效的反弹次数，用于计算一定时间内的反弹次数，防止无限抖动
            //较低的冲击力算作一次不正常反弹，根据游戏实际设定来设置临界值
            //cc.log(selfCollider.body.linearVelocity);  //可能需要实际测量
            if (Math.abs(selfCollider.body.linearVelocity.x) <= 20 && Math.abs(selfCollider.body.linearVelocity.y) <= 152) {
                this._collideWallCount++;
            }
        };


    }

    update (dt) {
        this._collideWallCountTimeCheck +=dt;
        if (this._collideWallCountTimeCheck >= 0.2) {
            this._collideWallCountTimeCheck = 0;
            //0.2秒内，如果连续反弹3次则不合理，需要让刚体沉睡，根据游戏实际设定来设置临界值
            //cc.log(this._collideWallCount); //可能需要实际测量
            if (this._collideWallCount >= 3) {
                this._collideWallCount = 0;
                this.body.awake = false;
            } else {
                this._collideWallCount = 0;
            }
        }
    }
}
